Attribute VB_Name = "modQuickSort"
Option Explicit

Public CC As Long 'a global counter for the comparisons

'Port from Java of the Dual-Pivot Quicksort, as suggested by Vladimir Yaroslavskiy in February 2009
'now the default Array-Sorting-algo in the official JDK-sources:
'http://cr.openjdk.java.net/~alanb/6880672/webrev.00/src/share/classes/java/util/Arrays.java.html
Public Sub DualPivotQuickSort(Arr() As Long, ByVal LB As Long, ByVal UB As Long)
Dim i As Long, j As Long, M1 As Long, M2 As Long
Dim P1 As Long, P2 As Long, Tmp As Long  '<- adjust types here, when switching to something different than Long
 
  If (UB - LB) < 27 Then  ' insertion sort for remaining tiny ranges
    For i = LB To UB - 1
      Tmp = Arr(i + 1)
        For j = i To LB Step -1
          CC = CC + 1
          If Tmp < Arr(j) Then Arr(j + 1) = Arr(j) Else Exit For
        Next j
      Arr(j + 1) = Tmp
    Next i
    Exit Sub
  End If

  M1 = LB + (UB - LB) \ 3: M2 = UB - M1 + LB '"medians"
  
  CC = CC + 1
  If Arr(M1) < Arr(M2) Then i = LB: j = UB Else i = UB: j = LB
  Tmp = Arr(M1): Arr(M1) = Arr(i): Arr(i) = Tmp
  Tmp = Arr(M2): Arr(M2) = Arr(j): Arr(j) = Tmp
 
  P1 = Arr(LB): P2 = Arr(UB) 'pivots
  M1 = LB + 1:  M2 = UB - 1  '... and Medians switched into "pointers"
  
  'sorting
  i = M1 - 1
  Do While i < M2 '<- M2 decreases within this loop, so we cannot use a For Next one
    i = i + 1
    
    CC = CC + 1
    If P1 > Arr(i) Then
      Tmp = Arr(i): Arr(i) = Arr(M1): Arr(M1) = Tmp
      M1 = M1 + 1

    ElseIf P2 < Arr(i) Then
    
      Do While M2 > i
        CC = CC + 1
        If P2 < Arr(M2) Then M2 = M2 - 1 Else Exit Do
      Loop
      
      If P1 <= Arr(M2) Then
        Tmp = Arr(i): Arr(i) = Arr(M2): Arr(M2) = Tmp
        M2 = M2 - 1
      Else
        Tmp = Arr(i): Arr(i) = Arr(M1): Arr(M1) = Arr(M2): Arr(M2) = Tmp
        M2 = M2 - 1: M1 = M1 + 1
      End If
    Else
      CC = CC + 1
    End If
  Loop
  
  Tmp = Arr(M1 - 1): Arr(M1 - 1) = Arr(LB): Arr(LB) = Tmp
  Tmp = Arr(M2 + 1): Arr(M2 + 1) = Arr(UB): Arr(UB) = Tmp

  DualPivotQuickSort Arr, LB, M1 - 2 'recurse into lower subarray
  DualPivotQuickSort Arr, M2 + 2, UB 'recurse into upper subarray

  If (M2 - M1) > (UB - LB - 21) Then  'handle equal elements
    CC = CC + 1
    If P1 <> P2 Then
      i = M1 - 1
      Do While i < M2 '<- M2 decreases within this loop, so we cannot use a For Next one
        i = i + 1
        CC = CC + 1
        If P1 = Arr(i) Then
          Arr(i) = Arr(M1): Arr(M1) = P1
          M1 = M1 + 1

        ElseIf P2 = Arr(i) Then
          CC = CC + 1
          If P1 <> Arr(M2) Then
            Arr(i) = Arr(M2): Arr(M2) = P2
            M2 = M2 - 1
          Else
            Arr(i) = Arr(M1): Arr(M1) = P1: Arr(M2) = P2
            M2 = M2 - 1: M1 = M1 + 1
          End If
        Else
          CC = CC + 1
        End If
      Loop
    End If
  End If

  If P1 < P2 Then DualPivotQuickSort Arr, M1, M2 'recurse into remaining subarray
End Sub

Public Sub NaiveQuickSort(Arr() As Long, ByVal LB As Long, ByVal UB As Long)
Dim M1 As Long, M2 As Long
Dim Piv As Long, Tmp As Long '<- adjust types here, when switching to something different than Long

    M1 = LB
    M2 = UB
    Piv = Arr(M1 + (M2 - M1) \ 2) 'create the Pivot-Element
 
    Do
      Do While (Arr(M1) < Piv): M1 = M1 + 1: CC = CC + 1: Loop: CC = CC + 1
      Do While (Arr(M2) > Piv): M2 = M2 - 1: CC = CC + 1: Loop: CC = CC + 1
      
      If M1 <= M2 Then
        Tmp = Arr(M1): Arr(M1) = Arr(M2): Arr(M2) = Tmp 'swap

        M1 = M1 + 1
        M2 = M2 - 1
      End If
    Loop Until M1 > M2
    
    If M2 > LB Then NaiveQuickSort Arr, LB, M2
    If M1 < UB Then NaiveQuickSort Arr, M1, UB
End Sub

Public Sub QuickSortExtended(Arr() As Long, ByVal LB As Long, ByVal UB As Long)
Dim M1 As Long, M2 As Long
Dim Piv As Long, Tmp As Long '<- adjust types here, when switching to something different than Long
  If UB - LB = 1 Then
     M1 = LB
     CC = CC + 1
     If Arr(M1) > Arr(UB) Then Tmp = Arr(M1): Arr(M1) = Arr(UB): Arr(UB) = Tmp
     Exit Sub
  Else
    M1 = (LB + UB) \ 2
    CC = CC + 1
    If Arr(M1) = Arr(LB) Then
      M2 = UB - 1
      M1 = LB
      Do
        M1 = M1 + 1
        If M1 > M2 Then
          CC = CC + 1
          If Arr(UB) < Arr(LB) Then Tmp = Arr(LB): Arr(LB) = Arr(UB): Arr(UB) = Tmp
          Exit Sub
        End If
        CC = CC + 1
      Loop Until Arr(M1) <> Arr(LB)
      Piv = Arr(M1)
      If M1 > LB Then
        CC = CC + 1
        If Arr(LB) > Piv Then Arr(M1) = Arr(LB): Arr(LB) = Piv: Piv = Arr(M1)
      End If
    Else
      Piv = Arr(M1)
      M1 = LB
      Do While (Arr(M1) < Piv): M1 = M1 + 1: CC = CC + 1: Loop
      CC = CC + 1
    End If
  End If
  
  M2 = UB
  Do
    Do While (Arr(M2) > Piv): M2 = M2 - 1: CC = CC + 1: Loop
    CC = CC + 1
    If M1 <= M2 Then
      Tmp = Arr(M1): Arr(M1) = Arr(M2): Arr(M2) = Tmp 'swap
      M1 = M1 + 1
      M2 = M2 - 1
    End If
    If M1 > M2 Then Exit Do
    Do While (Arr(M1) < Piv): M1 = M1 + 1: CC = CC + 1: Loop
    CC = CC + 1
  Loop
  If LB < M2 Then QuickSortExtended Arr, LB, M2
  If M1 < UB Then QuickSortExtended Arr, M1, UB
End Sub
